#ifndef __THREAD_S_H
#define __THREAD_S_H
#ifndef MAKEDEPEND
 #include <pthread.h>
 #include <set>
#endif
class mutex
{
protected:
	pthread_mutex_t mut;
public:
	mutex()
	{
		pthread_mutex_init(&mut, NULL);
	}
	~mutex(void)
	{
		pthread_mutex_destroy(&mut);
	}
	void lock()
	{
		 pthread_mutex_lock(&mut);
	}
	void unlock()
	{
		 pthread_mutex_unlock(&mut);
	}
};
static class threads
{
	set<pthread_t *> thr;
public:
	threads()
	{
	}
	~threads()
	{
		set<pthread_t *>::iterator i;
		for(i=thr.begin(); i!=thr.end(); ++i)
		{
			pthread_cancel(**i);
			delete *i;
		}
	}
	void add(void *(*func)(void *), void *arg)
	{
		pthread_t *t = new pthread_t;
		pthread_create(t, NULL, func, arg);
		thr.insert(t);
	}
} ThreadManager;
#endif
